/* emul.h */
/* Only used in TextWin */

/*
   Emulator interface for textwin.
*/


# ifndef EMUL_H
# define EMUL_H


// removing to see if can cure CAN clash
//# ifdef VT102
//#   ifndef VT102_H
//#     include "vt102.h"
//#   endif
//# endif


typedef int    (* EmulInitFn)(struct screen *);
typedef void   (* EmulTermFn)(struct screen *);
typedef void   (* EmulRecvCharFn)(struct screen *, int ch, int echo);
typedef void   (* EmulRecvStrFn)(struct screen *, char * str, int echo);
typedef char * (* EmulKeyFn)(struct screen *, int key);

struct emul
{
 char * name;
 char * desc;

 EmulInitFn     emulInit;
 EmulTermFn     emulTerm;
 EmulRecvCharFn emulRecvChar;
 EmulRecvStrFn  emulRecvStr;
 EmulKeyFn      emulKey;
};


struct tty_emulInfo
{
  int dummy;
};


# ifdef VT102

struct vt102_emulInfo 
{
 char * GL;
 char * G0;
 char * G1;

	char   esc_queue[30];   /* Current escape characters */
	char * line_attrs;
	int    esc_ptr;	/* pointer to esc_queue */
	int    scroll_top;
	int    scroll_bottom;
	int    store_x,
		      store_y,
		      store_attrib,
		      attrib;

	unsigned int flags;

# define VT102_INSERT    0x0001
/*
** #define DH_TOP       0x0002
** #define DH_BOTTOM    0x0004
** #define DOUBLE_WIDTH 0x0008
*/
# define ECHO            0x0010
# define PRINT_CTRL      0x0020
# define WRAP            0x0040
# define EMUL_ANSI       0x0080
# define CURSOR          0x0100
# define CURSOR_APPL     0x0200
# define KEYPAD_APPL     0x0400
# define RETURN_CRLF     0x0800
# define PRINTER_FF	     0x1000
# define PRINT_FULL	     0x2000
# define TTY 		          0x4000
# define COORDS_REL	     0x8000

	unsigned int bold        :1,
		            half        :1,
				          blink       :1,
				          underline   :1,
				          reverse     :1,
				          print_auto  :1,
				          reverse_scrn:1;
};

# endif /* VT102 */



union emulInfo
{
 struct tty_emulInfo tty;

# ifdef VT102

 struct vt102_emulInfo vt102;

# endif

};


extern struct emul Emulations[];

# define EMUL_TTY   0

# ifdef VT102
# define EMUL_VT102 1
# endif

# define EMUL_DEFAULT EMUL_TTY


void emulGotoXY __ARGS((struct screen *, int, int));
void	emulMoveLines __ARGS((struct screen *,int,int,int));
void	emulMoveChars __ARGS((struct screen *,int,int,int,int));
int  emulWhereX __ARGS((struct screen * scrn));
int  emulWhereY __ARGS((struct screen * scrn));
void emulFillRect __ARGS((struct screen* scrn,int xLo,int yLo,int xHi,int yHi,int filler));


struct emul * getSessionDefEmulation __ARGS((struct session *));
struct emul * findEmulation __ARGS((char *));

extern struct emul * DefEmulation;


# endif /* EMUL_H */

/* eof: emul.h */
