/****************************************************************************
*	$Id: filter.h 1.3 1997/05/25 16:34:22 Graham Exp $
*	14 Jun 93	1.2		GT	Enable ip_filter () prototype.					*
*	   May 97	1.3		GeK	Incomplete struct decls to fix warnings			*
****************************************************************************/
#ifndef _FILTER_H
#define _FILTER_H

#ifndef _GLOBAL_H
#include "global.h"
#endif

/*
 *  GeK - added incomplete forward declarations to fix gcc warnings
 *  Including full header files causes too many dependency problems
 */
struct ip;		/*  ip.h  */
struct mbuf;	/*  mbuf.h  */

#define FILTER_ACTION_DENY 1
#define FILTER_ACTION_PERMIT 2

/*
 *   Filter entry structure.
 */
struct filter {
	struct filter	*next;		/* Link to next filter element	*/
	short		action;		/* Filter entry match action	*/
	int		(*type) __ARGS((struct mbuf *bp, struct ip *ip, struct filter *fp));	/* Packet type comparison f(x)	*/
	struct filtersd {
	  	unsigned long addr;	/* Address used for comparisons	*/
		unsigned long mask;	/* Address comparison mask	*/
		unsigned char bits;	/* One bits in high part of mask*/
		unsigned char exclude;	/* Exclude matching addresses	*/
		unsigned short port;	/* TCP/UDP port (low of range)	*/
		unsigned short hiport;	/* High port of range		*/
	} src, dest;
	unsigned long	matches;	/* Number of matching packets	*/
};

int doipfilter __ARGS(( int argc, char *argv[], void *p ));
int ip_filter __ARGS(( struct mbuf *bp, struct ip *ip, struct filter *fp ));

#endif /* _FILTER_H */
