/* Internet finger client
 * Copyright 1991 Phil Karn, KA9Q
 */

/****************************************************************************
*	$Id: finger.c 1.3 1997/06/10 22:04:52 Graham Exp $
*	13 Sep 92	1.2		CMS		Make "finger @siteX@siteY" work.			*
*	   May 97	1.3		GeK		add /W for finger -l, tidied screen output	*
****************************************************************************/


#include <stdio.h>
#include <string.h>
#include "global.h"
#include "mbuf.h"
#include "socket.h"
#include "session.h"
#include "proc.h"
#include "netuser.h"
#include "commands.h"
#include "tty.h"

int
dofinger(argc,argv,p)
int argc;
char *argv[];
void *p;
{
	struct sockaddr_in sock;
	char *cp;
	int s,i;
	struct mbuf *bp;
	struct session *sp;
	int	do_long = 0;	/*  GeK - flag for -l  */

	/*  GeK - make session name to skip -l  */
	cp = ((argv[1][0] == '-' && argv[2] != NULL) ? argv[2] : argv[1]);
	/* Allocate a session descriptor */
	if((sp = newsession(cp,FINGER)) == NULLSESSION){
		tputs("Too many sessions\n");
		keywait(NULLCHAR,1);
		return 1;
	}
	sp->ttystate.echo = sp->ttystate.edit = 0;
	sp->flowmode = 1;
	sock.sin_family = AF_INET;
	sock.sin_port = IPPORT_FINGER;
	for(i=1;i<argc;i++){
		if (stricmp ("-l", argv[i]) == 0) {
			do_long = 1;
			continue;	/*  for ()  */
		}

		cp = strrchr(argv[i],'@');
		if(cp == NULLCHAR){
			tprintf("%s: local names not supported\n",argv[i]);
			continue;
		}
		*cp++ = '\0';
		tprintf("%s@%s -- Resolving %s... ",argv[i],cp,cp);
		if((sock.sin_addr.s_addr = resolve(cp)) == 0){
			tprintf("Host %s unknown\n",cp);
			continue;
		}
		tprintf("trying %s",psocket((struct sockaddr *)&sock));
		if((sp->s = s = socket(AF_INET,SOCK_STREAM,0)) == -1){
			tputs("\nCan't create socket\n");		/*  GeK - newline  */
			break;
		}
		sockmode(s,SOCK_ASCII);
		if(connect(s,(char *)&sock,sizeof(sock)) == -1){
			cp = sockerr(s);
			tprintf("\nConnect failed: %s\n",cp != NULLCHAR ? cp : "");		/*  GeK - newline  */
			close_s(s);
			sp->s = -1;
			continue;
		}
		tputc('\n');
		if (do_long)
			usputs (s, "/W ");	/*  GeK  */
		usprintf(s,"%s\n",argv[i]);
		usflush(Curproc->output);
		while(recv_mbuf(s,&bp,0,NULLCHAR,(int *)0) > 0){
			send_mbuf(Curproc->output,bp,0,NULLCHAR,0);
		}
		close_s(s);
		sp->s = -1;
	}
	keywait(NULLCHAR,1);
	freesession(sp);
	return 0;
}
