/****************************************************************************
*	$Id: pc.h 1.5 1997/11/25 14:24:26 Graham Exp $
*	15 Jul 93	1.2		GT	Fix warnings.									*
*	   May 97	1.4		GeK	Merged TextWin conditionals, fixed Shutdown and	*
*	         	   		   	chtimer prototypes, added ansi_putc() from		*
*	         	   		   	global.h, fix struct session warning			*
*	   Nov 97	1.5		GeK	Added UMB support fns from pc.c					*
****************************************************************************/

#ifndef	_PC_H
#define	_PC_H
#define _HARDWARE_H

#ifndef	_GLOBAL_H
#include "global.h"
#endif

#ifndef _SESSION_H
#include "session.h"
#endif

#ifdef	TEXTWIN
#  ifndef TEXTWIN_H
#    include "textwin.h"
#  endif
#  ifndef EMUL_H
#    include "emul.h"
#  endif
#endif	/* TEXTWIN */

#define	NSW	10	/* Number of stopwatch "memories" */

struct stopwatch {
	long calls;
	int16 maxval;
	int16 minval;
};
struct screen {
	char *save;		/* Screen save buffer */
	int row;		/* Saved cursor location */
	int col;

#ifdef	TEXTWIN

	HWINDOW hWnd; /* The window associated with this session */

#  ifdef  EMULATION

	struct emul     * emul;
	union  emulInfo * emulInfo;	/* Field used only by the emulation   */
	                           	/* to store state information         */
	                           	/* This pointer should be alloced in  */
	                           	/* emulInit() and freed in emulTerm() */

#  endif  /* EMULATION */

	int far * videoRAM; /* Ptr to char/attr buffer */
	int width;
	int height;

#endif	/* TEXTWIN */
};
#define	NULLSCREEN	(struct screen *)0

extern struct stopwatch Sw[];
extern int16 Intstk[];	/* Interrupt stack defined in pcgen.asm */
extern void (*Shutdown[]) __ARGS((void));	/* List of functions to call at shutdown */
extern int Mtasker;	/* Type of multitasker, if any */

/* In 8250.c: */
void asytimer __ARGS((void));

/* In scc.c: */
void scctimer __ARGS((void));
void sccstop __ARGS((void));

/* In pc.c: */
struct session;		/*  GeK - incomplete forward decln to fix warning  */
void newscreen __ARGS((struct session *sp));
void freescreen __ARGS((struct session *sp));
long bioscnt __ARGS((void));
void clrbit __ARGS((unsigned port,char bits));
void ctick __ARGS((void));
int32 divrem __ARGS((int32 dividend,int16 divisor));
INTERRUPT  (*getirq __ARGS((unsigned int)) ) __ARGS((void));
int getmask __ARGS((unsigned irq));
void ioinit __ARGS((void));
void iostop __ARGS((void));
void kbint __ARGS((void));
#ifdef	VT102
void kbfeed __ARGS((char *s));
#endif
int kbread __ARGS((void));
int maskoff __ARGS((unsigned irq));
int maskon __ARGS((unsigned irq));
void pctick __ARGS((void));
void setbit __ARGS((unsigned port,char bits));
int setirq __ARGS((unsigned irq,INTERRUPT (*handler) __ARGS((void))));
void sysreset __ARGS((void));
void systick __ARGS((void));
void writebit __ARGS((unsigned port,char mask,int val));
void smartdrive_commit_cache (void);		/*  GeK - for SMTP server  */
void enable_umbs (void);	/*  GeK - link UMBs to DOS memory chain  */
void disable_umbs (void);	/*  GeK - restore DOS memory config  */

/* In pcgen.asm: */
INTERRUPT btick __ARGS((void));
void chktasker __ARGS((void));
void chtimer __ARGS((INTERRUPT (*)(void)));
int32 divrem __ARGS((int32 dividend,int16 divisor));
int16 getss __ARGS((void));
void giveup __ARGS((void));
int kbraw __ARGS((void));
int16 longdiv __ARGS((int16 divisor,int n,int16 *dividend));
int16 longmul __ARGS((int16 multiplier,int n,int16 *multiplicand));
INTERRUPT nullvec __ARGS((void));
void uchtimer __ARGS((void));
int16 clockbits __ARGS((void));

/* In stopwatch.asm: */
void swstart __ARGS((void));
int16 stopval __ARGS((void));

/* In sw.c: */
void swstop __ARGS((int n));

/*  GeK - moved from global.h and removed ANSI conditional  */
/* In ansi.c: */
void ansi_putc __ARGS((struct screen *sp,char c));

#endif	/* _PC_H */

