/* textwin.h */

# ifndef TEXTWIN_H 
# define TEXTWIN_H 

# ifdef TEXTWIN

# if defined(_MSC_VER)

/* MICROSOFT MSC 7 */

# pragma intrinsic(_enable, _disable)

# define FAR __far

# define BEGIN_ASM _asm {
# define END_ASM   }

# define INTERRUPT_MODIFIERS __interrupt FAR __cdecl

typedef void (INTERRUPT_MODIFIERS * InterruptRoutine)();


# elif defined(__BORLANDC__)


# define FAR far

# define BEGIN_ASM asm {
# define END_ASM   }

# define INTERRUPT_MODIFIERS interrupt FAR /* cdecl */

typedef void (INTERRUPT_MODIFIERS * InterruptRoutine)();


# endif




typedef void           VOID;
typedef unsigned short USHORT;
typedef short          SHORT;
typedef unsigned char  UCHAR;
typedef unsigned char  BYTE;
typedef UCHAR FAR *    PCHAR;
typedef USHORT         BOOLEAN;
typedef USHORT         BOOL;
typedef SHORT FAR *    PSHORT;
typedef USHORT FAR *   PUSHORT;
typedef VOID FAR *     PVOID;
typedef char FAR *     PSZ;
typedef BYTE FAR *     PBYTE;
typedef unsigned int   WORD;


# define FALSE 0
# define TRUE  1



// HWINDOW is the type by which you should refer to
// a "window". It is a "handle" to a window. Just treat it
// as a magic cookie ... (no don't eat it ...)
// It's actually a far pointer to a window structure,
// but you're not allowed to know the internals of this ...

#define HWINDOW PVOID
#define BOOLEAN USHORT

void    TextwinInit(void);

BOOLEAN InitTextWinModule(void);
void    TermTextWinModule(void);

void    ShowWindow(HWINDOW hWindow, BOOL show);
void    UpdateWindow(HWINDOW pWindow);
HWINDOW DefaultAllocWindow(void);
HWINDOW AllocWindow(USHORT x, USHORT y, USHORT w, USHORT h);
HWINDOW AllocTerminalWindow(USHORT x, USHORT y, USHORT w, USHORT h);
void    FreeWindow(HWINDOW pWindow);
void    ClearWindow(HWINDOW pWindow);
void    FrameWindow(HWINDOW pWindow);
USHORT  GetScreenWidth(void);
USHORT  GetScreenHeight(void);
HWINDOW GetDesktopWindow(void);
HWINDOW GetWindowFocus(void);
HWINDOW GetWindowTop(void);
HWINDOW GetWindowBottom(void);
BOOLEAN SetWindowFocus(HWINDOW newFocus);
void    FreeWindow(HWINDOW pWindow);
void    SetWindowID(HWINDOW pWindow, USHORT id);
USHORT  GetWindowID(HWINDOW pWindow);
void    WindowSetPos(HWINDOW hWindow, SHORT x, SHORT y);
BOOLEAN MoveWindowBehind(HWINDOW pWindow, HWINDOW pWindowBehind);
BYTE    GetWindowAttribute(HWINDOW pWindow);
void    SetWindowAttribute(HWINDOW pWindow, BYTE attribute);
void    SetBorderAttribute(HWINDOW pWindow, BYTE attribute);
void    EnableWindowUpdate(HWINDOW pWindow, BOOLEAN enable);
void    EnableWindowBorder(HWINDOW pWindow, WORD enable);
void    TTYWindowPutc(HWINDOW pWindow, char ch);
void    TTYWindowWrite(HWINDOW pWindow, PSZ s);
void    BringWindowToTop(HWINDOW hWindow);
void    SetWindowUserData(HWINDOW hWindow, PVOID userData);
PVOID   GetWindowUserData(HWINDOW hWindow);
void    UpdateCursorDisplay(HWINDOW pWindow);
void    SetWindowCaption(HWINDOW pWindow, PSZ caption);

int     GetTerminalWidth(HWINDOW pWindow);
int     GetTerminalHeight(HWINDOW pWindow);
unsigned char*  GetTerminalBuffer(HWINDOW pWindow);
void    UpdateLogicalRect( HWINDOW hWindow,
                           int loX,
                           int hiX,
                           int loY,
                           int hiY );
void    TextwinGotoXY(HWINDOW pWindow, int x, int y);
int     GetCursorX(HWINDOW pWindow);
int     GetCursorY(HWINDOW pWindow);
void    TextwinSuspend(void);
void    TextwinResume(void);

void    mouseProcess(int,void *, void *);
int     dotextwin __ARGS((int argc,char *argv[],void *p));


void ResetDirtyArea(HWINDOW pWindow);
void UpdateDirtyArea(HWINDOW pWindow);
void AddDirtyXY(HWINDOW pWindow, int x, int y);
void AddDirtyY(HWINDOW pWindow, int y);
void AddDirtyCurXY(HWINDOW pWindow);
void AddDirtyCurY(HWINDOW pWindow);
void AddDirtyYRange(HWINDOW pWindow, int y, int dy);
void AddDirtyRect(HWINDOW pWindow, int x0, int y0, int x1, int y1);

void PutDirtyStrAt(HWINDOW pWindow, int x, int y, PSZ str);
void PutDirtyCharAt(HWINDOW pWindow, int x, int y, char ch);

int  IsTextwinSystemKeystroke(int key);

# endif

# endif /* TEXTWIN_H */

/* eof textwin.h */


