/* textwinv.c */

/*
   Global variables (<spit> on principle) used by textwin.
*/


#include "config.h"
#include "global.h"
#include "textwin.h"
#include "textwinp.h"


# ifdef TEXTWIN



int param[TW_PARAM_LAST] = { 
                             0,      // TW_PARAM_NULL
                             0xb1,   // TW_PARAM_DESKTOP_CHAR
                             0x77,   // TW_PARAM_WIBBLE_FACTOR

                           };  /* Miscellaneous configurable */
                               /* parameters.                */


int wantBorders = 1; /* Non-zero if we want borders on non-desktop */
                     /* windows. Zero if no borders are wanted.    */

int mouseKind = 1; /* mouseKind is 1 if WE will handle all mouse */
                   /* position indications; set it to 0 if you   */
                   /* want to display the hardware mouse cursor. */
                   /* The hardware mouse leaves mouse droppings  */
                   /* all over my S3 card's 132 x 43 mode.       */

int defaultWindowX  = 0;  /* The default window position and size */
int defaultWindowY  = 0;  /* (NB: These values are subject to the */
int defaultWindowDX = 80; /* normal sizing constraints)           */
int defaultWindowDY = 25;

int cascadeRangeX = 10; /* The cascade... values supply offsets to the   */
int cascadeRangeY = 10; /* default window position. They are designed    */
int cascadeOffsetX = 0; /* to allow the user to see (normally) both the  */
int cascadeOffsetY = 0; /* new and old window captions by offsetting     */
                        /* the new window position by 1. The user may    */
                        /* respecify the cascadeRange values, which      */
                        /* are limits to the cascade offsets.            */
                        /* eg: window 1 might be placed at def pos (0,0) */
                        /* With cascadeRangeX=0 and cascadeRangeY=3,     */
                        /* window 2 would be at (0,1) and window 3 would */
                        /* be placed at (0,2). However, window 4 would   */
                        /* hit the cascadeRangeY limit and so be placed  */
                        /* back at the default position. Thus setting    */
                        /* both cascadeRange values to zero disables the */
                        /* cascade feature.  Cascading only operates on  */
                        /* windows created using the DefaultAllocWindow()*/
                        /* routine.                                      */

int defaultLogicalWidth  = 80; /* The 'logical' dimensions are the   */
int defaultLogicalHeight = 25; /* sizes of the virtual screen which  */
                               /* is displayed by each window.       */
                               /* Please bear in mind the memory     */
                               /* required to hold these is quite    */
                               /* large: 2 * width * height bytes.   */
                               /* So an 80 x 50 display is 8000      */
                               /* bytes. Memory can disappear very   */
                               /* quickly if you start opening lots  */
                               /* of large windows...                */

int scrRestore = TRUE; /* If this is true then heap space will   */
                       /* be allocated at startup to save the    */
                       /* contents of the screen before the      */
                       /* windows startup. On shutdown, the      */
                       /* original screen contents will be       */
                       /* replaced.                              */

int scrMode = -1;      /* The screen mode. If this is positive,  */
                       /* that mode will be switched to before   */
                       /* the windows start. If negative, this   */
                       /* is the mode we found active at startup */

int forceMono = FALSE; /* If this is true, the windows will be   */
                       /* opened on the mono screen of a dual-   */
                       /* screen PC.                             */

int autoScrollToCursor = 0x01; /* If TRUE, cursor motion beyond the  */
                               /* window boundary will cause the     */
                               /* logical buffer to be scrolled into */
                               /* a position such that the cursor is */
                               /* made visible.                      */
                               /* Bit 0 == scroll vertically         */
                               /* Bit 1 == scroll horizontally (yuk!)*/


USHORT defaultWindowAttribute = 0; /* The colour used by newly       */
                                   /* created windows. This value    */
                                   /* can change and will take       */
                                   /* effect from the _next_ window  */
                                   /* that is created.               */
                                   /* AMcC : 12Dec92 : We initialise */
                                   /* this to zero (black on black)  */
                                   /* so that we can detect any user */
                                   /* specified settings in the .cfg */
                                   /* file.  Previously, such values */
                                   /* were being vaped by setup code */

char far singleFrameChars[] = "Ŵ\x12\x18\x19\x11\x10\x1e\x1f\xc5\xc5\xc4\xb3"; /* Chars used in window  */
char far doubleFrameChars[] = "Ȼι\x12\x18\x19\x11\x10\x1e\x1f\xd8\xd7\xcd\xba"; /* borders. Both strings */
                                         /* MUST contain at least */
                                         /* 22 characters...      */

int        screenWidth  = 80; /* default */
int        screenHeight = 25;
int        screenCharHeight = 8;
void FAR * screenBuffer;

int        forcedToMono;                
int        isMonoScreen;                


HWINDOW topwindow;     // Top-most window
HWINDOW focuswindow;   // Window that takes keystrokes
HWINDOW desktopwindow; // The window that forms the background




# endif /* TEXTWIN */

/* eof: textwinv.c */
