/* vt102.h */

#ifndef _VT102_H
#define _VT102_H

/*
   VT102 routines for textwin.
*/

#ifndef _CONFIG_H_
#include "config.h"
#endif

#ifndef _PC_H_
#include "pc.h"
#endif





#ifdef VT102
#define term_putc(s,x) vt102_putc(s,x,0)
#define term_puts(s,x) vt102_puts(s,x,0)
#define echo_putc(s,x) vt102_putc(s,x,1)
#define echo_puts(s,x) vt102_puts(s,x,1)
#define vt102_key(scrn,x) translate_vt102(scrn,x)
#else
#define term_putc(s,x) putc(x,Rawterm)
#define term_puts(s,x) fputs(x,Rawterm)
#define echo_putc(s,x) putc(x,Rawterm)
#define echo_puts(s,x) fputs(x,Rawterm)
#define vt102_key(x) NULL
#endif


#define TAB 9
#define LF 10
#define VT 11
#define FF 12
#define CR 13
#define CAN 24
#define SUB 26
#define ESC 27

/* in VT102.C */
void	vt102_putc __ARGS((struct screen *scrn, int c,int echo));   //> 2nd param changed char -> int 2.15
void	vt102_puts __ARGS((struct screen *scrn,char *s,int echo));

/* in VT102PC.C */
#ifdef __TURBOC__
#include <bios.h>
#define print_char(x) biosprint(0,x,0);

void	my_gotoxy __ARGS((struct screen *scrn,int x,int y));

#define my_wherex(scrn)  ((scrn)->col)
#define my_wherey(scrn)  ((scrn)->row)

void	Cursor_Up __ARGS((struct screen *scrn, int n));
void	Cursor_Right __ARGS((struct screen *scrn, int n));
void	clr_eos __ARGS((struct screen *scrn));
void	clr_bos __ARGS((struct screen *scrn));
void	clr_scr __ARGS((struct screen *scrn));
void	clr_bol __ARGS((struct screen *scrn));
void	clr_line __ARGS((struct screen *scrn));
void	do_tab	__ARGS((struct screen *scrn));
void	do_lf	__ARGS((struct screen *scrn));
void	set_xy	__ARGS((struct screen *scrn, unsigned int x,unsigned int y));
void	store_posn __ARGS((struct screen *scrn));
void	restore_posn __ARGS((struct screen *scrn));
void	rev_index __ARGS((struct screen *scrn));
void	term_vt102 __ARGS((struct screen *scrn));
int 	init_vt102 __ARGS((struct screen *scrn));
int 	init_big_vt102 __ARGS((struct screen *scrn));
void	restore_vt102 __ARGS((struct screen *scrn));
void	set_attr __ARGS((struct screen *scrn, char *s));
void	ins_char __ARGS((struct screen *scrn));
void	del_char __ARGS((struct screen *scrn, int n));
void	ins_line __ARGS((struct screen *scrn, int n));
void	del_line __ARGS((struct screen *scrn, int n));
void	set_cursor __ARGS((struct screen *scrn, int n,int m));
void	curpos_report __ARGS((struct screen *scrn));
char	*translate_vt102 __ARGS((struct screen *scrn, int c));
void	save_scrn __ARGS((struct screen *scrn));
void	set_video_mode __ARGS((struct screen *scrn));
void	clr_eol __ARGS((struct screen *scrn));
void	console_putc __ARGS((struct screen *scrn, int c));
void	set_line_attr __ARGS((struct screen *scrn,int n));
void	clrscrn __ARGS((struct screen *scrn));

void addDirtyCurY __ARGS((struct screen * scrn));
void addDirtyCurXY __ARGS((struct screen * scrn));
void addDirtyY __ARGS((struct screen * scrn, int y));
void addDirtyXY __ARGS((struct screen * scrn, int x, int y));
void addDirtyYRange __ARGS((struct screen * scrn, int y, int dy));
void addDirtyRect __ARGS((struct screen * scrn, int x0, int y0, int x1, int y1));

#endif


#endif

/* eof: vt102.h */
